#!/usr/bin/pike7

// This is pike program for the form module. (c) Martin Baehr 1997

// showdata 
// shows the data produced by the form module for simple diagnostics

//  This code is (c) 1996-1999 Martin Baehr, and can be used, modified and
//  redistributed freely under the terms of the GNU General Public License,
//  version 2.
//  This code comes on a AS-IS basis, with NO WARRANTY OF ANY KIND, either
//  implicit or explicit. Use at your own risk.
//  You can modify this code as you wish, but in this case please
//  - state that you changed the code in the modified version
//  - do not remove my name from it
//  - send me a copy of the modified version or a patch, so that
//    I can include it in the 'official' release.
//  If you find this code useful, please e-mail me. It would definitely
//  boost my ego :)
//  
//  For risks and side-effects please read the code or ask your local 
//  unix or roxen-guru.

string cvs_version = "$Id: showdata.pike,v 1.3 1999/07/30 09:15:19 mbaehr Exp $";

#include <roxen.h>
inherit "roxenlib";

// we need to overwrite roxenlibs make_tag_attributes() because it 
// assumes that foo=foo is equivalent to foo, which is not true for html

static string make_tag_attributes(mapping in){
  array a=indices(in), b=values(in);
  for(int i=0; i<sizeof(a); i++)
    if(stringp(b[i]))
      if(is_safe_string(b[i]))
        a[i]+="="+b[i];
      else
        // Bug inserted again. Grmbl.
        a[i]+="=\""+replace(b[i], ({ "\"", "<", ">" //, "&"
        }) ,
                            ({ "&quot;", "&lt;", "&gt;" //, "&amp;"
                            }))+"\"";
  return a*" ";
}

mixed main(mapping res, object id)
{
  mapping m,n;
  int i,j;
  string out = "";
  array index, a;

//  perror(sprintf("form: show: res->form: %d", sizeof(res->form)));

  out += "<br>\n";

  for(i=0; i<sizeof(res->form); i++)
  {
    m=res->form[i];
    if (m->tag)
      out += "tag:" + make_tag(m->tag, m->arguments);
      if (m->arguments->type=="hidden")
        out += "hidden:" + m->arguments->name + "=" + m->arguments->value;
    if (m->container == "select")
    {
      perror(sprintf("form: show: select: opt: %d", sizeof(m->opt)));
      string options;
      for(j=0; j<sizeof(m->opt); j++)
      {
        n=m->opt[j];
        if(n->arguments->type=="hidden")
        out += "hidden:" + n->contents + "<br>\n";
        options += make_container(n->container, n->arguments, n->contents) + "\n";
      }
      out += "select: " + make_container(m->container, m->arguments, options);
    }
    else if (m->container == "textarea")
      out += "container:" + make_container(m->container, m->arguments, m->contents);
    out += "<br>\n";
//    perror(sprintf("form: show: i: %d, out: %d", i, sizeof(out)));
  }

//  index=indices(res->data); 
//
//  for(i=0; i<sizeof(index); i++)
//  {
//    a=res->data[index[i]]->value;
//    for(j=0; j<sizeof(a); j++)
//      out += sprintf("%t: %d: %t<br>\n", index[i], j, a[j]);
//  }

  out += sprintf("<pre><hr>\n%O\n<hr>\n%O</pre>", id->variables, res); 



  return http_string_answer(parse_rxml(make_container("form", ([]), out), id), "text/html");
//  return http_string_answer("<form>"+out+"</form>", "text/html");

}
